/***************************************************************************
 *   Copyright (C) 2010 by Stefan Baur                                     *
 *   kwatersaver@c0n.de                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA            *
 ***************************************************************************/

#ifndef KWATERSAVER4_H__
#define KWATERSAVER4_H__

#include "kscreensaver.h"
#include "ui_kwatersaversettings.h"
#include "kglwatersaver4.h"

/**
@author Stefan Baur
*/
class KWaterSaver4 : public KScreenSaver
{
    Q_OBJECT
public:
    KWaterSaver4( WId drawable );
    virtual ~KWaterSaver4();

protected:
    void resizeEvent( QResizeEvent *e );

private:
    KGLWaterSaver4 * kglwatersaver4;
};


class KWaterSaver4Setup : public KDialog
{
    Q_OBJECT
public:
    KWaterSaver4Setup( QWidget *parent = NULL );
    ~KWaterSaver4Setup();

private slots:
	void slotOkPressed();
	void slotHelp();
	void slotDefault();
	
	void updateFPS(int fps);
	void updateBackgroundSource(QString src);
	void setBackgroundSourceDesktop(bool on);
	void setBackgroundSourceFile(bool on);
	void updateWaterResX(int x);
	void updateWaterResY(int y);
	
	void toggleEffectRain(bool on);
	void toggleEffectWhirl(bool on);
	void toggleEffectBlob(bool on);
	
	void toggleRenderLighting(bool on);
	void toggleRenderEnvironment(bool on);

private:
    void initDialog();
    KGLWaterSaver4 *saver;
    Ui::KWaterSaverSettings ui;
};

#endif
